/**
 *	@file DonutPFunc.h
 *	@brief	DonutP ̔ėp֐.
 */

#ifndef __DONUTPFUNC_H__
#define __DONUTPFUNC_H__

#pragma once

#include "MtlMisc.h"
#include "IniFile.h"


extern const char	g_cSeparater[];



/*+++ gpt@CPȂ̂łɈړ.
//#define PI						3.141592653589793238462643383279
//#define ANGLE_TO_RADIAN( a )	( (a) * PI / 180.0 )
//#define RADIAN_TO_ANGLE( a )	( (a) / PI * 180.0 )
*/


double	_GetAngle(CPoint pt1, CPoint pt2);


BOOL	_CheckOsVersion_98Later();
BOOL	_CheckOsVersion_MELater();
BOOL	_CheckOsVersion_2000Later();
BOOL	_CheckOsVersion_XPLater();
BOOL	_CheckOsVersion_VistaLater();
BOOL	_IsWow64(); 					//+++


CString GetExeDirectory();
__inline CString _GetFilePath(const CString& strFile) { return GetExeDirectory() + strFile; }
//x CString _GetBtnSkinDir();
CString _GetSkinDir();
CString _GetRecentCloseFile();
bool	_LoadToolTipText(int nCmdID, CString &strText);
//x BOOL IsSJISLeadByte(BYTE c);


// strText  nFirst ڂAnCount 擾ĕԂB}`oCgΉ
CString RtlMbbStrMid(CString strText, const int &nFirst = 0, const int &nCount = 1);

CString RtlGetSelectedText(const WTL::CEdit &edit);


//EM_GETSELVisualStyleKpUNICODEI(UNICODE`Ȃꍇł)̂łȂƂ֐
CString _GetSelectTextWtoA(CEdit &edit);
CString _GetSelectText(CEdit &edit);
CString _GetSelectText_OnCursor(CEdit &edit);		//+++

BOOL	_AddSimpleReBarBandCtrl(HWND hWndReBar,
								HWND hWndBand,
								int nID 				= 0,
								LPTSTR lpstrTitle		= NULL,
								BOOL bNewRow			= FALSE,
								int cxWidth 			= 0,
								BOOL bFullWidthAlways	= FALSE);
bool	FileWriteString(const CString& strFile, std::list<CString>* pString);
bool	FileReadString(const CString& strFile, std::list<CString>* pString);

BOOL	_SetCombboxCategory(CComboBox &cmb, HMENU hMenu);
BOOL	_DontUseID(UINT uID);
void	_PickUpCommandSub(HMENU hMenuSub, CComboBox &cmbCmd);
void	_PickUpCommand(HMENU hMenu, int nPopup, CComboBox &cmbCmd);


//minit
BOOL	_ReplaceImageList(CString strBmpFile, CImageList &imgs, DWORD dfltRes=0);
//BOOL	_ReplaceImageList(HBITMAP hBitmap, CImageList &imgs);		//+++
//x int _Pack(int hi, int low); 	//+++ static
BOOL	_QueryColorString(CIniFileI &pr, COLORREF &col, LPCTSTR lpstrKey);



//-----------------------------------
//+++ ǉ.
CString 		GetExeFileName();
bool			IsExistManifestFile();
const CString	GetStrWord(const TCHAR* str, const TCHAR** ppNext=0);
void			SeptTextToWords(std::vector<CString>& strs, const TCHAR* line);
void			SeptTextToLines(std::vector<CString>& strs, const TCHAR* text);
const CString	ConvPathNameToAlNumName(const TCHAR* src);
void			MoveToBackupFile(const CString& strFile);
const CString	GetDirName(const CString& strFileName);
const CString	GetFileBaseName(const CString& strFileName);
const CString	GetFileExt(const CString& strFileName);
void			ErrorLogPrintf(const char* fmt, ...);
const CString	GetFullPath_ForExe(const CString& strFileName);
const CString	GetCurDirectory();
int 			SetCurDirectory(const CString& strDir);
__inline bool	IsExistFile(const char* name) { return (::GetFileAttributes(name) != 0xFFFFFFFF); }
CString 		GetFavoriteLinksFolder_For_Vista();
int 			GetFontHeight(HFONT hFont);

HRESULT 		RegKey_QueryStringValue(CRegKey& rk, const TCHAR* key, TCHAR* dst, DWORD* pCount);
HRESULT 		RegKey_SetStringValue(CRegKey& rk, const TCHAR* value, const TCHAR* key);
HRESULT 		RegKey_SetDWORDValue(CRegKey& rk, const TCHAR* key, DWORD value);
HRESULT 		RegKey_QueryDWORDValue(CRegKey& rk, const TCHAR* key, DWORD& value);

//template<typename T, typename T2, typename B> __inline
//void SET_FLAG_SW(T& val, T2 mask, B sw) { val = (sw) ? (T)(val |	mask) : (T)(val & ~mask); }

int 			ForceMessageLoop(HWND hWnd=0);

//x ///+++ LvV̎Ac[o[̌Ԃ߂悤ɂ邽߂ɁALvV͂񂾃t֐.
//x  bool			Donut_FakeCaptionLButtonDown(HWND hWnd, HWND hWndTopLevelParent, LPARAM lParam);

#endif
