 /**
 *	@file	SearchBar.cpp
 *	@brief	o[
 *	@note
 *		templateŎĂ SearchBar.h 𕁒ʂclassɂ .h, .cpp .
 */


#include "stdafx.h"
#include "DonutPFunc.h"
#include "DonutViewOption.h"
#include "MtlDragDrop.h"
#include "ExplorerMenu.h"
#include "HlinkDataObject.h"
#include "FlatComboBox.h"
#include "ExStyle.h"
#include <atlctrls.h>
#include "StringEncoder.h"
#include <winnls32.h>
#include "ParseInternetShortcutFile.h"
#include "Donut.h"

#include "SearchBar.h"



//extern bool		g_bNoReposition;



//+++	ParseInternetShortcutFile()pɎ蔲Ŏg̃|C^p...
CDonutSearchBar*	CDonutSearchBar::s_pThis_ = 0;




CDonutSearchBar::CDonutSearchBar()
	: m_wndKeyword(this, 1)
	, m_wndEngine  (this, 2)
	, m_wndKeywordCombo(this, 3)
	, m_hThread(0)				//+++
	, m_cxBtnsBtn(0)			//+++ p
	, m_clrMask(0)				//+++
	, m_bActiveWindow(0)		//+++
	, m_hWndKeywordList(0)		//+++
	, m_has(0)					//+++
	, m_dwNoWordButton(0)		//+++
	, m_nDefDlgH(22)			//+++
	, m_nItemFontH(21)			//+++
{
	//m_hThreadEngine  = NULL;	//+++ gpۂ.
	//m_hThreadKeyword= NULL;	//+++ gpۂ.
	m_hCursor		  = NULL;

	m_bDragAccept	  = false;
	m_bDragFromItself = false;
	m_bShowToolBar	  = FALSE;
	m_bLoadedToolBar  = FALSE;

	m_bFiltering	  = FALSE;

	m_bUseShortcut	  = FALSE;
	m_bActiveWindow   = FALSE;

	//+++ 1CX^XȂA낤ƂāAParseInternetShortcutFile()pɎ蔲Ȏw|C^.
	ATLASSERT(s_pThis_ == 0);
	s_pThis_ = this;
}




//Ȃɂ`悪ȂoOfix minit
LRESULT CDonutSearchBar::OnEraseBkgnd(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled)
{
	// CAddressBarCtrlImplRsy
	HWND	hWnd	= GetParent();
	CPoint	pt(0, 0);

	MapWindowPoints(hWnd, &pt, 1);
	pt = ::OffsetWindowOrgEx( (HDC) wParam, pt.x, pt.y, NULL );
	LRESULT lResult = ::SendMessage(hWnd, WM_ERASEBKGND, wParam, 0L);
	::SetWindowOrgEx( (HDC) wParam, pt.x, pt.y, NULL );
	//return lResult;
	return 1; //lResult;

	//bHandled = TRUE;
	//::SendMessage(GetParent(), uMsg, wParam, lParam);
	//return 1;
}



LRESULT CDonutSearchBar::OnToolTipText(int idCtrl, LPNMHDR pnmh, BOOL & /*bHandled*/)
{
	LPNMTTDISPINFO pDispInfo  = (LPNMTTDISPINFO) pnmh;

	pDispInfo->szText[0] = 0;
	if (pDispInfo->uFlags & TTF_IDISHWND)
		return S_OK;

	CString 	   strKeyword = MtlGetWindowText(m_wndKeyword);
	CString 	   strHeader  = _T('\"');
	CString 	   strHelp	  = _T("\" ");
	CString 	   strEngine   = MtlGetWindowText(m_wndEngine);

	TCHAR		   szBuff[80+4];
	AtlCompactPathFixed( szBuff, strKeyword, 80 - strHelp.GetLength() - strHeader.GetLength() );

	strHeader	+= szBuff;
	strHeader	+= strHelp;

	switch (idCtrl) {
	case ID_SEARCH_WEB: 		strHeader += _T("\"") + strEngine + _T("\"Ō"); 				break;
	case ID_SEARCHBAR_HILIGHT:	strHeader += _T("nCCg");										break;
	case ID_SEARCH_PAGE:		strHeader += _T("̃y[WŌ(:Shift+Enter :Ctrl+Enter)");	break;
	default:	// ID_SEARCH_WORD00..09
		return S_OK;
	}

	::lstrcpyn(pDispInfo->szText, strHeader, 80);

	return S_OK;
}



void CDonutSearchBar::OnCommand(UINT uFlag, int nID, HWND hWndCtrl)
{
	if (hWndCtrl == m_wndToolBar.m_hWnd) {
		CEdit	edit = GetEditCtrl();
		CString str  = MtlGetWindowText(edit);

		switch (nID) {
		case ID_SEARCH_WEB: 		_OnCommand_SearchWeb(str);								break;
		case ID_SEARCHBAR_HILIGHT:	_OnCommand_SearchHilight(str);							break;	//ID_SEARCH_HILIGHT:
		//+++ case ID_SEARCH_PAGE:	_OnCommand_SearchPage( (::GetKeyState(VK_SHIFT) < 0) ? FALSE : TRUE );	break;
		case ID_SEARCH_PAGE:		_OnCommand_SearchPage( (::GetKeyState(VK_SHIFT) >= 0)); break;
		case ID_SEARCHBAR_WORD00:
		case ID_SEARCHBAR_WORD01:
		case ID_SEARCHBAR_WORD02:
		case ID_SEARCHBAR_WORD03:
		case ID_SEARCHBAR_WORD04:
		case ID_SEARCHBAR_WORD05:
		case ID_SEARCHBAR_WORD06:
		case ID_SEARCHBAR_WORD07:
		case ID_SEARCHBAR_WORD08:
		case ID_SEARCHBAR_WORD09:
		case ID_SEARCHBAR_WORD10:
		case ID_SEARCHBAR_WORD11:
		case ID_SEARCHBAR_WORD12:
		case ID_SEARCHBAR_WORD13:
		case ID_SEARCHBAR_WORD14:
		case ID_SEARCHBAR_WORD15:
		case ID_SEARCHBAR_WORD16:
		case ID_SEARCHBAR_WORD17:
		case ID_SEARCHBAR_WORD18:
		case ID_SEARCHBAR_WORD19:
			_OnCommand_SearchPage((::GetKeyState(VK_SHIFT) >= 0), nID-ID_SEARCHBAR_WORD00);
			break;

		default:
			ATLASSERT(0);
		}

		SetMsgHandled(TRUE);
		return;
	}

	SetMsgHandled(FALSE);
}



void	CDonutSearchBar::_OnCommand_SearchWeb(CString &str, int no /*=-1*/)
{
  #if 1
	bool bUrlSearch = false;
	if (::GetFocus() != m_wndKeyword.m_hWnd) {
	   #if 1	//Ȃ̂ŁAՂŁAdg݂𒼂
		// I͈͂΁AD悷.
		CString strSel = Donut_GetActiveSelectedText();
		if (strSel.IsEmpty() == 0) {
			str = strSel;
		}
	   #endif
		if (str.IsEmpty())	//+++ 񂪋̏ꍇ.
		{
			CString 		strSearchEng  = MtlGetWindowText(m_cmbEngine);
			if (strSearchEng.IsEmpty())
				return;
			CString 		strSearchPath = GetSearchIniPath();
			CIniFileI		pr(strSearchPath, strSearchEng);
			DWORD			exPropOpt = pr.GetValue("ExPropOpt", 0);
			pr.Close();
			if (exPropOpt & 1) {	// addressbar̕Ăꍇ.
				CString strUrl = GetAddressBarText();
				if (strUrl.IsEmpty() == 0) {
					str 	  = strUrl;
					bUrlSearch = true;
				}
			}
		  #if 0 //Ȃ̂ŁAՂŁAdg݂𒼂
			if (str.IsEmpty()) {
				//x str = g_pMainWnd->GetActiveSelectedText();
				str = Donut_GetActiveSelectedText();
			}
		  #endif
		}
	}
  #endif

	toolBarAddWords(/*str*/);			//+++ T[`̃c[o[ɒPݒ

	if ( !str.IsEmpty() ) {
	  #if 1 //+++	template߂̂thisł.
		this->OnItemSelected(str);
	  #else
		T *pT = static_cast<T *>(this);
		pT->OnItemSelected(str);
	  #endif
		if (bUrlSearch == false)		//+++ urlꍇ́AɓȂŒu.
			_AddToSearchBoxUnique(str);
	}
}




void CDonutSearchBar::_OnCommand_SearchHilight(CString &str)
{
	checkToolBarWords();	//+++

	str = RemoveShortcutWord(str);

	if (m_bFiltering)
		FilterString(str);

	SendMessage(GetTopLevelParent(), WM_USER_HILIGHT, (WPARAM) str.GetBuffer(0), 0);
}



void CDonutSearchBar::_OnCommand_SearchPage(BOOL bForward, int no /*=-1*/)
{
	checkToolBarWords();	//+++

	CEdit	edit	= GetEditCtrl();
  #if 1 //+++ J[\ʒu̒PꂾI悤ɂĂ݂.
	CString str;
	if (no >= 0) {
		str 	= _GetSelectText(edit);
		//pEV[gJbg[h͏O
		str = RemoveShortcutWord(str);
		if (m_bFiltering)
			FilterString(str);
		std::vector<CString> strs;
		strs.reserve(10);
		SeptTextToWords(strs, str);
		if (size_t(no) < strs.size())
			str = strs[no];
	} else {
		str 	= _GetSelectText_OnCursor(edit);
		//pEV[gJbg[h͏O
		str = RemoveShortcutWord(str);
	}
  #else
	CString str 	= _GetSelectText(edit);
	//pEV[gJbg[h͏O
	str = RemoveShortcutWord(str);
  #endif

	CString strExcept = _T(" \t\"\r\n@");
	str.TrimLeft(strExcept);
	str.TrimRight(strExcept);
	if (m_bFiltering)
		FilterString(str);

	SendMessage(GetTopLevelParent(), WM_USER_FIND_KEYWORD, (WPARAM) str.GetBuffer(0), (LPARAM) bForward);
}




//public
CString CDonutSearchBar::RemoveShortcutWord(CString &str)
{
	if (m_bUseShortcut) {
		if (str.Find( _T("\\") ) == 0 || str.Find( _T("/") ) == 0) {
			int nPos = str.Find( _T(" ") );

			if (nPos != -1)
				return str.Mid(nPos + 1);
		}
	}

	return str;
}


// private:
LRESULT CDonutSearchBar::OnSize(UINT /*uMsg*/, WPARAM /*wParam*/, LPARAM /*lParam*/, BOOL& /*bHandled*/)
{
  #if 1 //+++ P{^̂Ƃ
	//+++ Pڂɂ邽߁Ao[̃TCY@ύX.
	if (m_dwNoWordButton == 0) {
		return ResizeBar(0,0);
	} else
  #endif
	{
		//+++ P{^̏ꍇ͋.

		//if (!m_wndToolBar.m_hWnd)
		//	return S_FALSE;
		if (!m_wndKeyword.m_hWnd)
			return S_FALSE;

		CRect	rcDlg;
		GetClientRect(&rcDlg);

		CRect	rcToolbar(rcDlg);
		CString str;

		if (rcDlg.right == 0)
			return S_FALSE;

		if ( GetToolIconState() && m_wndToolBar.m_hWnd ) {
			rcToolbar.left = rcDlg.right - m_cxBtnsBtn - 10;
			m_wndToolBar.SetWindowPos(NULL, rcToolbar, SWP_NOZORDER | SWP_NOSENDCHANGING);
		} else {
			//\
			rcToolbar.left = rcDlg.right;
		}

		CRect	rcEngine;
		m_cmbEngine.GetWindowRect(&rcEngine);
		int 	nEngineCX = rcEngine.Width();
		int 	nEngineCY = rcEngine.Height();
		rcEngine		 = rcToolbar;
		rcEngine.right	 = rcToolbar.left - s_kcxGap;
		rcEngine.left	 = rcEngine.right - nEngineCX;
		rcEngine.top	 = m_nDefEditT; //minit
		rcEngine.bottom  = rcEngine.top + nEngineCY;
		m_cmbEngine.SetWindowPos(NULL, rcEngine, SWP_NOZORDER | SWP_NOSENDCHANGING);

		CRect	rcKeyword(rcEngine);
		rcKeyword.left	= 0;
		rcKeyword.right = rcEngine.left - s_kcxGap;
		m_cmbKeyword.SetWindowPos(NULL, rcKeyword, SWP_NOZORDER | SWP_NOSENDCHANGING);

		return S_OK;
	}
}



///+++ o[̃TCYύX. L[[hbGWbc[o[  ̋ڂł̈ړdifA,difBƂ.
int CDonutSearchBar::ResizeBar(int difA, int difB)
{
	if (!m_wndKeyword.m_hWnd)
		return S_FALSE;

	CRect	rcDlg;
	GetClientRect(&rcDlg);
	if (rcDlg.right == 0)
		return S_FALSE;

	//int	h = rcDlg.Height();

	CRect	rcKeyword;
	m_cmbKeyword.GetWindowRect(&rcKeyword);
	m_nKeywordWidth = rcKeyword.Width();
	int 		h	= rcKeyword.Height();
	m_nKeywordWidth += difA;
	if (m_nKeywordWidth <= 21)
		m_nKeywordWidth = 21;
	rcKeyword.left	= 0;
	rcKeyword.top	= m_nDefEditT;
	rcKeyword.right = m_nKeywordWidth;
	rcKeyword.bottom= rcKeyword.top + h;
	m_cmbKeyword.SetWindowPos(NULL, rcKeyword, SWP_NOZORDER | SWP_NOSENDCHANGING);

	CRect	rcEngine;
	m_cmbEngine.GetWindowRect(&rcEngine);
	h			  = rcEngine.Height();
	m_nEngineWidth = rcEngine.Width();
	m_nEngineWidth += difB;
	if (m_nEngineWidth <= 21)
		m_nEngineWidth = 21;
	rcEngine.left	 = rcKeyword.right + s_kcxGap;
	rcEngine.top	 = m_nDefEditT;
	rcEngine.right	 = rcEngine.left	+ m_nEngineWidth;
	rcEngine.bottom  = rcEngine.top + h;
	m_cmbEngine.SetWindowPos(NULL, rcEngine, SWP_NOZORDER | SWP_NOSENDCHANGING);

	CRect	rcToolbar(rcDlg);
	rcToolbar.left = rcEngine.right + s_kcxGap;
	if (rcToolbar.left > rcToolbar.right)
		rcToolbar.left = rcToolbar.right;
	if ( GetToolIconState() ) {
	} else {
		//\
		rcToolbar.left = rcDlg.right;
	}
	if (m_wndToolBar.m_hWnd)
		m_wndToolBar.SetWindowPos(NULL, rcToolbar, SWP_NOZORDER | SWP_NOSENDCHANGING);
	return S_OK;
}


//x void CDonutSearchBar::InitToolBar(/*+++ UINT nImageBmpID, UINT nHotImageBmpID,*/ int cx, int cy, COLORREF clrMask, UINT nFlags /*= ILC_COLOR24*/)
void CDonutSearchBar::InitToolBar(int cx, int cy, COLORREF clrMask, UINT nFlags /*= ILC_COLOR24*/)
{
	m_clrMask	= clrMask;

	CImageList	imgs;
	MTLVERIFY( imgs.Create(cx, cy, nFlags | ILC_MASK, 1, 1) );

	CBitmap 	bmp;
	bmp.Attach( AtlLoadBitmapImage(LPCTSTR(GetSkinSeachBarPath(0)), LR_LOADFROMFILE) );
	if (bmp.m_hBitmap == NULL)
		bmp.LoadBitmap(IDB_SEARCHBUTTON/*nImageBmpID*/);			//+++	skin̏ɂ̂ŁAftHgfނ̏ŐݒɂƂ...
	imgs.Add(bmp, clrMask);

	CImageList	imgsHot;
	MTLVERIFY( imgsHot.Create(cx, cy, nFlags | ILC_MASK, 1, 1) );

	CBitmap 	bmpHot;
	bmpHot.Attach( AtlLoadBitmapImage(LPCTSTR(GetSkinSeachBarPath(1)), LR_LOADFROMFILE) );
	if (bmpHot.m_hBitmap == NULL)
		bmpHot.LoadBitmap(IDB_SEARCHBUTTON_HOT/*nHotImageBmpID*/);		//+++	skin̏ɂ̂ŁAftHgfނ̏ŐݒɂƂ...
	imgsHot.Add(bmpHot, clrMask);

  #if 1 //+++ Disablepӂ
	CString str = GetSkinSeachBarPath(2);
	int 	dis = 0;
	if (IsExistFile(str) == 0) {	//+++ 摜t@CȂ
		if (IsExistFile(GetSkinSeachBarPath(0))) {	//+++ ʏ킪
			str = GetSkinSeachBarPath(0);			//+++ ʏőp
		} else {									//+++ ʏȂ
			dis = IDB_SEARCHBUTTON_DIS; 			//+++ ftHgDisableg.
		}
	}
	CImageList	imgsDis;
	MTLVERIFY( imgsDis.Create(cx, cy, nFlags | ILC_MASK, 1, 1) );
	CBitmap 	bmpDis;
	bmpDis.Attach( AtlLoadBitmapImage(LPCTSTR(str), LR_LOADFROMFILE) );
	if (bmpDis.m_hBitmap == NULL && dis)
		bmpDis.LoadBitmap(dis); 					//+++	skin̏ɂ̂ŁAftHgfނ̏ŐݒɂƂ...
	imgsDis.Add(bmpDis, clrMask);
  #endif

	CIniFileI	pr( g_szIniFileName, _T("SEARCH") );
	//DWORD 	jikken = pr.GetValue("Jikken");
	m_dwNoWordButton = pr.GetValue("NoWordButton");
	pr.Close();
	DWORD		flags  =  WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN | WS_CLIPSIBLINGS
						| CCS_NODIVIDER  /*| CCS_NORESIZE */ | CCS_NOPARENTALIGN | CCS_TOP
						| TBSTYLE_TOOLTIPS | TBSTYLE_FLAT ;
//+++	if (jikken)
	if (m_dwNoWordButton == 0)
		flags		  |= TBSTYLE_LIST | TBSTYLE_TRANSPARENT;	//+++ ǉ (P̕\ɂ͕Kv)

	m_wndToolBar	 = ::CreateWindowEx(
							0,
							TOOLBARCLASSNAME,
							NULL,
							// ATL_SIMPLE_TOOLBAR_PANE_STYLE|CCS_TOP,
							flags,
							0,
							0,
							100,
							100,
							m_hWnd,
							(HMENU) NULL,
							_Module.GetModuleInstance(),
							NULL							);

	m_wndToolBar.SetButtonStructSize( sizeof (TBBUTTON) );

	m_wndToolBar.SetImageList(imgs);
	m_wndToolBar.SetHotImageList(imgsHot);
	m_wndToolBar.SetDisabledImageList(imgsDis); //+++

 #if 1	//+++
	//if (m_dwNoWordButton) {	//+++ ̌(Pp{^Ȃ)
		static const TBBUTTON	btns[3] = {
			{ 0 		, ID_SEARCH_WEB,		TBSTATE_ENABLED, TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE	, 0, 0 },	// Web
			{ 2 		, ID_SEARCH_PAGE,		TBSTATE_ENABLED, TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE	, 0, 0 },	// Page
			{ 1 		, ID_SEARCHBAR_HILIGHT, TBSTATE_ENABLED, TBSTYLE_CHECK	| TBSTYLE_AUTOSIZE	, 0, 0 }, // Hilight
		};
		MTLVERIFY( m_wndToolBar.AddButtons(3, (TBBUTTON *) btns ) );
		m_wndToolBar.SetBitmapSize(14,14);
		if (m_dwNoWordButton) {
			m_cxBtnsBtn 	 = (20) * 3 + 1;
		}
	//} else {				//+++ Pp{^L
	//	static const TBBUTTON	btns[2] = {
	//		{ 0 		, ID_SEARCH_WEB,		TBSTATE_ENABLED, TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE	, 0, 0 },	// Web
	//		{ 1 		, ID_SEARCHBAR_HILIGHT, TBSTATE_ENABLED, TBSTYLE_CHECK	| TBSTYLE_AUTOSIZE	, 0, 0 },	// Hilight
	//	};
	//	MTLVERIFY( m_wndToolBar.AddButtons(2, (TBBUTTON *) btns ) );
	//}
	m_wndToolBar.AutoSize();
 #else
  #if 0
	if (jikken) {
		init_search_word_button_jikkenVersion();
	} else
  #endif
	{
		// add Add and Organize button
		static const TBBUTTON	btnWeb		= { 0, ID_SEARCH_WEB, TBSTATE_ENABLED, TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE, 0, 0 };
		MTLVERIFY( m_wndToolBar.InsertButton(-1, (TBBUTTON *) &btnWeb) );

		static const TBBUTTON	btnHilght	= { 1, /*ID_SEARCH_HILIGHT*/ ID_SEARCHBAR_HILIGHT, TBSTATE_ENABLED, TBSTYLE_CHECK | TBSTYLE_AUTOSIZE, 0, 0 };
		MTLVERIFY( m_wndToolBar.InsertButton(-1, (TBBUTTON *) &btnHilght) );

		static const TBBUTTON	btnPage 	= { 2, ID_SEARCH_PAGE, TBSTATE_ENABLED, TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE, 0, 0 };
		MTLVERIFY( m_wndToolBar.InsertButton( 1, (TBBUTTON *) &btnPage) );

		//m_wndToolBar.SetBitmapSize(14,14);
		//m_cxBtnsBtn	 = (20) * 3 + 1;
	}
  #endif

	m_bShowToolBar	 = TRUE;
	m_bLoadedToolBar = TRUE;
}


void	CDonutSearchBar::checkToolBarWords()	//+++
{
	toolBarAddWords(true);
}


//+++ [h̕𕪉āAc[o[ɒǉ
void CDonutSearchBar::toolBarAddWords(bool chk)
{
	CEdit	edit	= GetEditCtrl();

	CString str 	= _GetSelectText(edit);
	//pEV[gJbg[h͏O
	str = RemoveShortcutWord(str);
	if (m_bFiltering)
		FilterString(str);

	if (chk && m_toolBarAddWordStr == str)
		return;
	m_toolBarAddWordStr = str;

	std::vector<CString> strs;
	strs.reserve(10);
	SeptTextToWords(strs, str);

	toolBarAddWordTbl(strs);
}



//+++ vectorœnꂽ̕(10܂)c[o[ɓo^.
void CDonutSearchBar::toolBarAddWordTbl(std::vector<CString>& tbl)
{
	enum { TOP = 3/*2*/ };
	if (m_wndToolBar.m_hWnd == 0)
		return;
	unsigned num = m_wndToolBar.GetButtonCount();
	for (unsigned i = num; --i >= TOP;) {
		m_wndToolBar.DeleteButton(i);
	}

	CVersional<TBBUTTONINFO> bi;
	bi.cbSize	= sizeof(TBBUTTONINFO);
	bi.dwMask	= TBIF_TEXT/* | TBIF_STYLE*/;
	bi.fsStyle |= TBSTYLE_AUTOSIZE;

	unsigned n	= tbl.size();
	if (n > 20)
		n = 20;
	for (unsigned i = 0; i < n; ++i) {
		enum { STYLE = TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE }; // | TBSTYLE_LIST | TBSTYLE_TRANSPARENT };
		TBBUTTON	btn = { 2/*I_IMAGENONE*/, ID_SEARCHBAR_WORD00+i, TBSTATE_ENABLED, STYLE, 0, 0 };
		MTLVERIFY( m_wndToolBar.AddButton( (TBBUTTON *)&btn) );
		bi.pszText = (LPTSTR) LPCTSTR(tbl[i]);
		MTLVERIFY( m_wndToolBar.SetButtonInfo(ID_SEARCHBAR_WORD00+i, &bi) );

		//m_wndToolBar.AutoSize();
		//CRect rcButton;
		//m_wndToolBar.GetItemRect(TOP+i, rcButton);
		//m_wndToolBar.SetButtonSize(rcButton.Size());
	}
	m_wndToolBar.AutoSize();
	m_wndToolBar.Invalidate();
	//ShowToolBarIcon(true);
}



#if 0 //+++ y[W̕ŁAwʒu/{^ŒP邽߂̎.
	//		ƒP{^ăVFuΉČo[̕@ςāĉ
	//		ȂȂ΂ȂȂŁAܒ...
void CDonutSearchBar::init_search_word_button_jikkenVersion()
{
	//x int n = m_wndToolBar.AddStrings( "WEB\0Page\0hilight\0Wo\0" );

	// add Add and Organize button
	static const TBBUTTON	btns[3] = {
		{ 0 		, ID_SEARCH_WEB,		TBSTATE_ENABLED, TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE	, 0, 0 },	// Web
		{ 2 		, ID_SEARCH_PAGE,		TBSTATE_ENABLED, TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE	, 0, 0 },	// Page
		{ 1 		, ID_SEARCHBAR_HILIGHT, TBSTATE_ENABLED, TBSTYLE_CHECK	| TBSTYLE_AUTOSIZE	, 0, 0 }, // Hilight
	};
	MTLVERIFY( m_wndToolBar.AddButtons(3, (TBBUTTON *) btns ) );
	//m_cxBtnsBtn	 = (20) * (3+5) + 1;
  #if 1
	enum { STYLE = TBSTYLE_BUTTON | TBSTYLE_AUTOSIZE }; // | TBSTYLE_LIST | TBSTYLE_TRANSPARENT };
	static /*const*/ TBBUTTON	btns2[] = {
		{ I_IMAGENONE, ID_SEARCHBAR_WORD00, TBSTATE_ENABLED, STYLE, 0, 0 },
		{ I_IMAGENONE, ID_SEARCHBAR_WORD01, TBSTATE_ENABLED, STYLE, 0, 0 },
		{ I_IMAGENONE, ID_SEARCHBAR_WORD02, TBSTATE_ENABLED, STYLE, 0, 0 },
		{ I_IMAGENONE, ID_SEARCHBAR_WORD03, TBSTATE_ENABLED, STYLE, 0, 0 },
		{ I_IMAGENONE, ID_SEARCHBAR_WORD04, TBSTATE_ENABLED, STYLE, 0, 0 },
		//{ I_IMAGENONE, ID_SEARCHBAR_WORD05, TBSTATE_ENABLED, STYLE, 0, 0 },
		//{ I_IMAGENONE, ID_SEARCHBAR_WORD06, TBSTATE_ENABLED, STYLE, 0, 0 },
		//{ I_IMAGENONE, ID_SEARCHBAR_WORD07, TBSTATE_ENABLED, STYLE, 0, 0 },
		//{ I_IMAGENONE, ID_SEARCHBAR_WORD08, TBSTATE_ENABLED, STYLE, 0, 0 },
		//{ I_IMAGENONE, ID_SEARCHBAR_WORD09, TBSTATE_ENABLED, STYLE, 0, 0 },
	};
  #if 0
	btns2[0].iString = m_wndToolBar.AddStrings(_T("1"));
	btns2[1].iString = m_wndToolBar.AddStrings(_T("2"));
	btns2[2].iString = m_wndToolBar.AddStrings(_T("3"));
	btns2[3].iString = m_wndToolBar.AddStrings(_T("4"));
	btns2[4].iString = m_wndToolBar.AddStrings(_T("5"));
	//btns2[5].iString = m_wndToolBar.AddStrings(_T("6"));
	//btns2[6].iString = m_wndToolBar.AddStrings(_T("7"));
	//btns2[7].iString = m_wndToolBar.AddStrings(_T("8"));
	//btns2[8].iString = m_wndToolBar.AddStrings(_T("9"));
	//btns2[9].iString = m_wndToolBar.AddStrings(_T("0"));
	MTLVERIFY( m_wndToolBar.AddButtons( 10, (TBBUTTON *)&btns2[0]) );
   #else

	MTLVERIFY( m_wndToolBar.AddButton( (TBBUTTON *)&btns2[0]) );
	MTLVERIFY( m_wndToolBar.AddButton( (TBBUTTON *)&btns2[1]) );
	MTLVERIFY( m_wndToolBar.AddButton( (TBBUTTON *)&btns2[2]) );
	MTLVERIFY( m_wndToolBar.AddButton( (TBBUTTON *)&btns2[3]) );
	MTLVERIFY( m_wndToolBar.AddButton( (TBBUTTON *)&btns2[4]) );
	//MTLVERIFY( m_wndToolBar.AddButton( (TBBUTTON *)&btns2[5]) );
	//MTLVERIFY( m_wndToolBar.AddButton( (TBBUTTON *)&btns2[6]) );
	//MTLVERIFY( m_wndToolBar.AddButton( (TBBUTTON *)&btns2[7]) );
	//MTLVERIFY( m_wndToolBar.AddButton( (TBBUTTON *)&btns2[8]) );
	//MTLVERIFY( m_wndToolBar.AddButton( (TBBUTTON *)&btns2[9]) );

	CVersional<TBBUTTONINFO> bi;
	bi.cbSize	= sizeof(TBBUTTONINFO);
	bi.dwMask	= TBIF_TEXT/* | TBIF_STYLE*/;
	bi.fsStyle |= TBSTYLE_AUTOSIZE;
	bi.pszText = _T("1");
	MTLVERIFY( m_wndToolBar.SetButtonInfo(ID_SEARCHBAR_WORD00, &bi) );
	bi.pszText = _T("2");
	MTLVERIFY( m_wndToolBar.SetButtonInfo(ID_SEARCHBAR_WORD01, &bi) );
	bi.pszText = _T("3");
	MTLVERIFY( m_wndToolBar.SetButtonInfo(ID_SEARCHBAR_WORD02, &bi) );
	bi.pszText = _T("4");
	MTLVERIFY( m_wndToolBar.SetButtonInfo(ID_SEARCHBAR_WORD03, &bi) );
	bi.pszText = _T("5");
	MTLVERIFY( m_wndToolBar.SetButtonInfo(ID_SEARCHBAR_WORD04, &bi) );
	//bi.pszText = _T("6");
	//MTLVERIFY( m_wndToolBar.SetButtonInfo(ID_SEARCHBAR_WORD05, &bi) );
	//bi.pszText = _T("7");
	//MTLVERIFY( m_wndToolBar.SetButtonInfo(ID_SEARCHBAR_WORD06, &bi) );
	//bi.pszText = _T("8");
	//MTLVERIFY( m_wndToolBar.SetButtonInfo(ID_SEARCHBAR_WORD07, &bi) );
	//bi.pszText = _T("9");
	//MTLVERIFY( m_wndToolBar.SetButtonInfo(ID_SEARCHBAR_WORD08, &bi) );
	//bi.pszText = _T("0");
	//MTLVERIFY( m_wndToolBar.SetButtonInfo(ID_SEARCHBAR_WORD09, &bi) );
   #endif
  #endif
  #if 1
	// TCYȂ
	m_wndToolBar.SetMaxTextRows(1);
	CRect rcButton;
	m_wndToolBar.GetItemRect(3, rcButton);
	m_wndToolBar.SetButtonSize(rcButton.Size());
	m_wndToolBar.SetButtonSize(rcButton.Size());
	m_wndToolBar.Invalidate();
  #endif
	m_wndToolBar.AutoSize();
}
#endif



CString 	CDonutSearchBar::GetSkinSeachBarPath(int mode/*BOOL bHot*/)
{
  #if 1 //+++ disableΉ
	ATLASSERT(mode >= 0 && mode <= 2);
	static const TCHAR* tbl[] = {
		_T("SearchBar.bmp"),
		_T("SearchBarHot.bmp"),
		_T("SearchBarDis.bmp"),
	};
	return _GetSkinDir() + tbl[ mode ];
  #else
	CString 	strBmp;
	if (bHot)
		strBmp = _T("SearchBarHot.bmp");
	else
		strBmp = _T("SearchBar.bmp");
	return _GetSkinDir() + strBmp;
  #endif
}



LRESULT CDonutSearchBar::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	CRect		rcDlg;
	GetWindowRect(&rcDlg);
	//SetWindowPos(NULL, 0, 0, 1, rcDlg.Height(), 0);
	SetWindowPos(NULL, 0, 0, 0, m_nDefDlgH , 0);
	CIniFileI	pr( g_szIniFileName, _T("SEARCH") );
	m_nKeywordWidth 	 = pr.GetValue( _T("KeywordWidth" ), 150 );
	m_nEngineWidth		 = pr.GetValue( _T("EngWidth"	  ), 150 );
	DWORD dwUseShortCut  = pr.GetValue( _T("UseShortcut"  ),   0 );
	pr.Close();

	if (dwUseShortCut)
		m_bUseShortcut = TRUE;

	//R{{bNX
	m_cmbKeyword.FlatComboBox_Install( GetDlgItem(IDC_CMB_KEYWORD) );
	m_cmbEngine.FlatComboBox_Install  ( GetDlgItem(IDC_CMB_ENGIN  ) );
	m_cmbEngine.SetDroppedWidth(150);
	_InitCombo();

	if (m_nKeywordWidth != 0) {
		CRect	rcKeyword;
		m_cmbKeyword.GetWindowRect(&rcKeyword);
		int 	h		 = rcKeyword.Height();
		rcKeyword.left	 = 0;
		rcKeyword.right  = m_nKeywordWidth;
		rcKeyword.top	 = 0;
		rcKeyword.bottom = h;
		m_cmbKeyword.SetWindowPos(NULL, rcKeyword, SWP_NOZORDER | SWP_NOSENDCHANGING);
	}
	if (m_nEngineWidth != 0) {
		CRect	rcEngine;
		m_cmbEngine.GetWindowRect(&rcEngine);
		int 	h		 = rcEngine.Height();
		rcEngine.left	= 0;
		rcEngine.right	= m_nEngineWidth;
		rcEngine.top	= 0;
		rcEngine.bottom = h;
		m_cmbEngine.SetWindowPos(NULL, rcEngine, SWP_NOZORDER | SWP_NOSENDCHANGING);
	}

	m_wndKeyword.SubclassWindow( m_cmbKeyword.GetDlgItem(IDC_EDIT/*1001*/) );
	m_wndEngine.SubclassWindow(m_cmbEngine.m_hWnd);
	m_wndKeywordCombo.SubclassWindow(m_cmbKeyword.m_hWnd); //minit

	//c[o[
	DWORD	dwShowToolBar = STB_SHOWTOOLBARICON;
	{
		CIniFileI		pr( g_szIniFileName, _T("SEARCH") );
		pr.QueryValue( dwShowToolBar, _T("Show_ToolBarIcon") );
	}
	m_bShowToolBar	= (dwShowToolBar & STB_SHOWTOOLBARICON) == STB_SHOWTOOLBARICON;

  #if 1 //+++ S([̖ʂS&hD)
	BOOL bShowToolBar = m_bShowToolBar;
	InitToolBar(/*+++ IDB_SEARCHBUTTON, IDB_SEARCHBUTTON_HOT,*/ m_nBmpCX, m_nBmpCY, RGB(255, 0, 255) );
	ShowToolBarIcon(bShowToolBar);
  #else //+++ ̏B\ȂჁ[BArŐݒ肵ꍇfontfȂ.
	if (m_bShowToolBar) {
		InitToolBar(/*+++ IDB_SEARCHBUTTON, IDB_SEARCHBUTTON_HOT,*/ m_nBmpCX, m_nBmpCY, RGB(255, 0, 255) );
	}
  #endif

	//hbOhbv
	RegisterDragDrop();

	//Xbh𗘗păR{{bNXɃf[^o^(INI̓ǂݍ݂ɎԂ邽)
	// Thread Create
	m_ThreadParams.m_hExitEvent  = ::CreateEvent(NULL, FALSE, FALSE, NULL);
	m_ThreadParams.m_pSearchBar  = this;
	DWORD		wThreadId	   = 0;
	//+++ m_hThread = ::CreateThread(NULL, 0, _SearchThread, (LPVOID) &m_ThreadParams, 0, &wThreadId);
	m_hThread	= (HANDLE)_beginthreadex(NULL, 0, _SearchThread, (LPVOID)&m_ThreadParams, 0, (UINT*)&wThreadId);

	::SetThreadPriority(m_hThread , THREAD_PRIORITY_IDLE);

	return S_OK;
}




//Xbh𗘗păR{{bNXɃf[^o^(INI̓ǂݍ݂ɎԂ邽)
//+++ static DWORD WINAPI _SearchThread(LPVOID lpParam)
UINT WINAPI CDonutSearchBar::_SearchThread(void* lpParam)
{
	_ThreadParam *pParam = (_ThreadParam *) lpParam;
	_InitialEngine	( (LPVOID) pParam->m_pSearchBar->m_cmbEngine.m_hWnd );
	_InitialKeyword( (LPVOID) pParam->m_pSearchBar->m_cmbKeyword.m_hWnd );
	//_endthread(); //?
	//+++ ::ExitThread(0);
	_endthreadex(0);
	return 0;
}


bool CDonutSearchBar::IsAliveSearchThread() const
{
	DWORD dwReturnCode = 0;
	::GetExitCodeThread(m_hThread, &dwReturnCode);
	return (dwReturnCode == STILL_ACTIVE);
}



//private:
void CDonutSearchBar::OnDestroy()
{
	// Thread Remove
	::SetEvent(m_ThreadParams.m_hExitEvent);
	DWORD	dwResult	  = ::WaitForSingleObject(m_hThread, DONUT_THREADWAIT);
	::CloseHandle(m_ThreadParams.m_hExitEvent);
	::CloseHandle(m_hThread);

  #if 0
	CRect			rcKeyword;
	m_wndKeyword.GetWindowRect(rcKeyword);
	DWORD			keywordW = rcKeyword.Width();
	CRect			rcEngine;
	m_wndEngine.GetWindowRect(rcEngine);
	DWORD			enginW	 = rcEngine.Width();
  #else
	if (m_dwNoWordButton) { //+++ ̂Ƃ̒날킹
		CRect			rcEngine;
		m_wndEngine.GetWindowRect(rcEngine);
		m_nEngineWidth = rcEngine.Width();
	}
  #endif
	{
		CIniFileIO	pr( g_szIniFileName, _T("SEARCH") );
		pr.SetValue( (DWORD) m_nKeywordWidth, _T("KeywordWidth") );
		pr.SetValue( (DWORD) m_nEngineWidth  , _T("EngWidth") );

		DWORD	dwShowToolBar = m_bShowToolBar ? STB_SHOWTOOLBARICON : 0;
		pr.SetValue( dwShowToolBar, _T("Show_ToolBarIcon") );

		DWORD	dwStatus	  = 0;
		pr.QueryValue( dwStatus, _T("Status") );
		if (dwStatus & STS_LASTSEL)
			pr.SetValue( m_cmbEngine.GetCurSel(), _T("SelIndex") );
		//x pr.Close(); //+++
	}

	m_wndKeyword.UnsubclassWindow();
	m_wndEngine.UnsubclassWindow();
	m_wndKeywordCombo.UnsubclassWindow();
	RevokeDragDrop();
	SaveHistory();
}



void CDonutSearchBar::OnEngineKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if (nChar == VK_RETURN) {
		_OnEnterKeyDown(ENTER_KEYDOWN_RETURN);
		SetMsgHandled(TRUE);
	} else if (nChar == VK_TAB) {
		m_cmbKeyword.SetFocus();
		SetMsgHandled(TRUE);
	} else {
		SetMsgHandled(FALSE);
	}
}



void CDonutSearchBar::OnChar(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	if (nChar == VK_RETURN) {
		SetMsgHandled(TRUE);
	} else {
		SetMsgHandled(FALSE);
	}
	//checkToolBarWords();	//+++
}



LRESULT CDonutSearchBar::OnCtlColorListBox(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL &bHandled)
{
	bHandled		  = FALSE;
	m_hWndKeywordList = (HWND) lParam;
	return 0;
}



void CDonutSearchBar::OnKeywordKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags)
{
	// if not dropped, eat VK_DOWN
	if ( !m_cmbKeyword.GetDroppedState() && (nChar == VK_DOWN || nChar == VK_UP) ) {
		int nIndexEngine   = m_cmbEngine.GetCurSel();
		int nIndexKeyword = m_cmbKeyword.GetCurSel();

		SetMsgHandled(TRUE);

		if (nChar == VK_UP) {
			if (::GetKeyState(VK_CONTROL) < 0) {
				if (0 > nIndexEngine - 1)
					m_cmbEngine.SetCurSel(m_cmbEngine.GetCount() - 1);
				else
					m_cmbEngine.SetCurSel(nIndexEngine - 1);
			} else {
				if (0 > nIndexKeyword - 1)
					m_cmbKeyword.SetCurSel(m_cmbKeyword.GetCount() - 1);
				else
					m_cmbKeyword.SetCurSel(nIndexKeyword - 1);
			}
		} else if (nChar == VK_DOWN) {
			if (::GetKeyState(VK_CONTROL) < 0) {
				int nIndex = m_cmbEngine.GetCurSel();

				if (m_cmbEngine.GetCount() > nIndexEngine + 1)
					m_cmbEngine.SetCurSel(nIndexEngine + 1);
				else
					m_cmbEngine.SetCurSel(0);
			} else {
				if (m_cmbKeyword.GetCount() > nIndexKeyword + 1)
					m_cmbKeyword.SetCurSel(nIndexKeyword + 1);
				else
					m_cmbKeyword.SetCurSel(0);
			}
		}
	} else {
		if (nChar == VK_RETURN) {
			_OnEnterKeyDown(ENTER_KEYDOWN_RETURN);
			SetMsgHandled(TRUE);
		} else if (nChar == VK_DELETE) {
			if ( m_cmbKeyword.GetDroppedState() ) {
				if ( DeleteKeywordHistory() )
					SetMsgHandled(TRUE);
			} else
				SetMsgHandled(FALSE);
		} else if (nChar == VK_TAB) {
			m_cmbEngine.SetFocus();
			SetMsgHandled(TRUE);
		} else
			SetMsgHandled(FALSE);
	}

	//+++ checkToolBarWords();	//+++
}



LRESULT CDonutSearchBar::OnKeywordCbnDropDown(LPNMHDR pnmh)
{
	if (m_cmbKeyword.GetCount() == 0)
		::MessageBox(NULL, "", "", MB_OK);

	return FALSE;
}



BOOL CDonutSearchBar::DeleteKeywordHistory()
{
	if ( !::IsWindow(m_hWndKeywordList) )
		return FALSE;

	CListBox List	= m_hWndKeywordList;
	int 	 nIndex = List.GetCurSel();

	if (nIndex == LB_ERR)
		return FALSE;

	m_cmbKeyword.DeleteString(nIndex);
	return TRUE;
}



struct CDonutSearchBar::_Function_MakeSearchFileListMenu {
	CMenuHandle 	menu;
	int 			nIndex;

	_Function_MakeSearchFileListMenu()
	{
		menu.CreatePopupMenu();
		menu.AppendMenu( 0, 1, _T("gvpeB") );
		menu.AppendMenu(MF_SEPARATOR);
		nIndex = 1;
	}

	void operator ()(CString strFile)
	{
		ATLTRACE(_T("%s\n"), strFile);

		nIndex++;
		menu.AppendMenu( 0, nIndex, MtlGetFileName(strFile) );
	}
};



void CDonutSearchBar::OnEngineRButtonUp(UINT nFlags, CPoint point)
{
	_Function_MakeSearchFileListMenu	__f;

	MtlForEachFileSortEx( GetExeDirectory() + _T("Search\\"), __f, _T("*.ini") );

	CPoint	pos;

	//GetCursorPos(&pos);
	ATLTRACE("mouseposition1 : left=%4d top=%4d", point.x, point.y);
	::ClientToScreen(m_cmbEngine.m_hWnd, &point);
	ATLTRACE("mouseposition2 : left=%4d top=%4d", point.x, point.y);
	CMenu	menu(__f.menu.m_hMenu);

	int 	nRet	 = menu.TrackPopupMenu( TPM_LEFTALIGN | TPM_TOPALIGN | TPM_LEFTBUTTON | TPM_RIGHTBUTTON | TPM_NONOTIFY | TPM_RETURNCMD,
							point.x,
							point.y,
							m_cmbEngine.m_hWnd);
	if (nRet == 0)
		return;

	if (nRet == 1) {
		if (!m_cmbEngine.IsWindow() || m_cmbEngine.GetCurSel() == CB_ERR)
			return;
		CString 		  strText;
		MtlGetLBTextFixed(m_cmbEngine, m_cmbEngine.GetCurSel(), strText);
		CExPropertyDialog dlg(GetSearchIniPath(), strText);
		dlg.SetTitle(strText);
		dlg.DoModal();
		return;
	}

	CString 		strTitle;
	menu.GetMenuString(nRet, strTitle, MF_BYCOMMAND);
	CString 		strPath = GetExeDirectory() + _T("Search\\") + strTitle;

	{
		CIniFileO	pr( g_szIniFileName, _T("Search") );
		pr.SetValue( strPath, _T("Path") );
		//x pr.Close();
	}

	RefreshEngine();
}



void	CDonutSearchBar::OnEngineSetFocus(HWND hWndBefore)
{
	SetMsgHandled(FALSE);
	::WINNLSEnableIME(m_cmbEngine, FALSE);
}



void	CDonutSearchBar::OnEngineKillFocus(HWND hWndNew)
{
	SetMsgHandled(FALSE);
	::WINNLSEnableIME(m_cmbEngine, TRUE);
}



void	CDonutSearchBar::OnMouseMove(UINT nFlags, const CPoint& pt)
{
  #if 1 //+++ P{^̏ꍇ
	if (m_dwNoWordButton == 0) {
		CRect	rcKeyword;
		m_cmbKeyword.GetWindowRect(&rcKeyword);
		ScreenToClient(&rcKeyword);
		if ((abs(rcKeyword.right - pt.x) <= 5 || (m_has == 1 && ::GetCapture() == m_hWnd))
			&& (rcKeyword.top <= pt.y && pt.y < rcKeyword.bottom)
		) {
			m_has = 1;
			if (m_hCursor == NULL)
				m_hCursor = ::LoadCursor(NULL, IDC_SIZEWE);
			::SetCursor(m_hCursor);
			if ( (nFlags & MK_LBUTTON) ) {
				UpdateLayout(pt);
			}
			return;
		}

		CRect	rcEngine;
		m_cmbEngine.GetWindowRect(&rcEngine);
		ScreenToClient(&rcEngine);
		if ( (abs(rcEngine.right - pt.x) <= 5 || (m_has == 2 && ::GetCapture() == m_hWnd))
			&& (rcEngine.top <= pt.y && pt.y < rcEngine.bottom)
		) {
			m_has = 2;
			if (m_hCursor == NULL)
				m_hCursor = ::LoadCursor(NULL, IDC_SIZEWE);
			::SetCursor(m_hCursor);
			if ( (nFlags & MK_LBUTTON) ) {
				UpdateLayout2(pt);
			}
			return;
		}
		m_has = 0;
		return;

	} else
  #endif
	{
		//+++ P{^̏ꍇ͋.
		CRect	rcKeyword;

		m_cmbKeyword.GetWindowRect(&rcKeyword);
		ScreenToClient(&rcKeyword);

		if ( abs(rcKeyword.right - pt.x) > 5 && ::GetCapture() != m_hWnd )
			return;

		if (m_hCursor == NULL)
			m_hCursor = ::LoadCursor(NULL, IDC_SIZEWE);

		::SetCursor(m_hCursor);

		if ( (nFlags & MK_LBUTTON) ) {
			UpdateLayout(pt);
		}
	}
}


#if 0
///+++ GWỈ... son_.
void CDonutSearchBar::OnSelDblClkForEngine(UINT code, int id, HWND hWnd)
{
	int 	nTarCate	 = m_cmbEngine.GetCurSel();
	if (nTarCate == -1)
		return;

	TCHAR	buf[4096];
	m_cmbEngine.GetLBText(nTarCate, buf);
	CString strSearchEng = buf;
	BOOL	bFirst		 = TRUE;
	int 	nLoopCtn	 = 0;

	CString  str;
	int nIndexCmb = m_cmbKeyword.GetCurSel();
	if (nIndexCmb == -1)
		str = MtlGetWindowText(m_cmbKeyword);
	else
		MtlGetLBTextFixed(m_cmbKeyword.m_hWnd, nIndexCmb, str);
	if ( !str.IsEmpty() )
		OpenSearch(str, strSearchEng, nLoopCtn, bFirst);
	return;
}
#endif



///+++ GWỈ... son_...ǁAƂLp.
void CDonutSearchBar::OnSelChangeForEngine(UINT code, int id, HWND hWnd)
{
  #if 1
	if (::GetKeyState(VK_RBUTTON) < 0) {
	  #if 1
		CString 			strText;
		MtlGetLBTextFixed(m_cmbEngine, m_cmbEngine.GetCurSel(), strText);
		CExPropertyDialog	dlg(GetSearchIniPath(), strText);
		dlg.SetTitle(strText);
		dlg.DoModal();
		return;
	  #else
		int 	nTarCate	 = m_cmbEngine.GetCurSel();
		if (nTarCate == -1)
			return;

		CString strSearchEng = MtlGetWindowText(m_cmbEngine);
		BOOL	bFirst		 = TRUE;
		int 	nLoopCtn	 = 0;

		CString  str;
		int nIndexCmb = m_cmbKeyword.GetCurSel();
		if (nIndexCmb == -1)
			str = MtlGetWindowText(m_cmbKeyword);
		else
			MtlGetLBTextFixed(m_cmbKeyword.m_hWnd, nIndexCmb, str);
		if ( !str.IsEmpty() )
			OpenSearch(str, strSearchEng, nLoopCtn, bFirst);
	  #endif
		return;
	}
  #endif
	CIniFileI		pr( g_szIniFileName, _T("SEARCH") );
	DWORD			dwStatus = pr.GetValue( _T("Status"), 0 );
	pr.Close();

	DWORD							 bSts = 0;
	if		(id == IDC_CMB_ENGIN)	 bSts = dwStatus & STS_ENG_CHANGE_GO;
	//x else if (id == IDC_CMB_KEYWORD)  bSts = dwStatus & STS_KEY_CHANGE_GO;

	if (::GetKeyState(VK_SHIFT) < 0) bSts = !bSts;

	if (bSts) {
		//+++ GW؂ւꍇ́Ałurl̏ꍇ̂ŁA
		//x _OnEnterKeyDown(ENTER_KEYDOWN_SELCHANGE);
		SearchWeb();
	}
}



void CDonutSearchBar::OnSelChange(UINT code, int id, HWND hWnd)
{
	DWORD			dwStatus = 0;
	{
		CIniFileI	pr( g_szIniFileName, _T("SEARCH") );
		pr.QueryValue( dwStatus, _T("Status") );
		//x pr.Close(); //+++
	}

	DWORD							 bSts = 0;
	//x if	(id == IDC_CMB_ENGIN)	 bSts = dwStatus & STS_ENG_CHANGE_GO; else		//+++ GW͕ʊ֐.
	if (id == IDC_CMB_KEYWORD)		 bSts = dwStatus & STS_KEY_CHANGE_GO;
	if (::GetKeyState(VK_SHIFT) < 0) bSts = !bSts;

	if (bSts) {
		_OnEnterKeyDown(ENTER_KEYDOWN_SELCHANGE);
	}
}



void CDonutSearchBar::OnLButtonDown(UINT nFlags, const CPoint& pt)
{
  #if 1 //+++ P{^̏ꍇ
	if (m_dwNoWordButton == 0) {
		CRect	rcKeyword;
		m_cmbKeyword.GetWindowRect(&rcKeyword);
		ScreenToClient(&rcKeyword);
		if (abs(rcKeyword.right - pt.x) <= 5) {
			m_has = 1;
			SetCapture();
			::SetCursor(m_hCursor);
			m_ptDragStart = pt;
			m_ptDragHist  = pt;
			return;
		}
		CRect	rcEngine;
		m_cmbEngine.GetWindowRect(&rcEngine);
		ScreenToClient(&rcEngine);
		if (abs(rcEngine.right - pt.x) <= 5) {
			m_has = 2;
			SetCapture();
			::SetCursor(m_hCursor);
			m_ptDragStart = pt;
			m_ptDragHist  = pt;
			return;
		}
		m_has = 0;
	} else
  #endif
	{
		//+++ P{^Ȃ̏ꍇ͋
		CRect	rcKeyword;
		m_cmbKeyword.GetWindowRect(&rcKeyword);
		ScreenToClient(&rcKeyword);

		if (abs(rcKeyword.right - pt.x) > 5)
			return;

		SetCapture();
		::SetCursor(m_hCursor);
		m_ptDragStart = pt;
		m_ptDragHist  = pt;
	}
}



void CDonutSearchBar::OnLButtonUp(UINT nFlags, const CPoint& pt)
{
	if (::GetCapture() != m_hWnd)
		return;

	::ReleaseCapture();

  #if 1 //+++ P{^̏ꍇ
	if (m_dwNoWordButton == 0) {
		if (m_has == 1)
			UpdateLayout(pt);
		else if (m_has == 2)
			UpdateLayout2(pt);
	} else
  #endif
	{
		UpdateLayout(pt);
	}
}



void CDonutSearchBar::UpdateLayout(const CPoint& pt)
{
  #if 1 //+++ P{^̏ꍇ
	if (m_dwNoWordButton == 0) {
		ResizeBar(pt.x - m_ptDragStart.x, 0);
		m_ptDragStart	 = pt;
		UpdateWindow();
	} else
  #endif
	{
		int 	nMoveX = m_ptDragStart.x - pt.x;
		CRect	rcKeyword;

		m_cmbKeyword.GetWindowRect(&rcKeyword);
		ScreenToClient(&rcKeyword);
		rcKeyword.right -= nMoveX;

		CRect rcEngine;
		m_cmbEngine.GetWindowRect(&rcEngine);
		ScreenToClient(&rcEngine);
		rcEngine.left	-= nMoveX;

		if (rcEngine.left >= rcEngine.right)
			return;

		if (rcKeyword.left >= rcKeyword.right)
			return;

		m_cmbKeyword.SetWindowPos(NULL, rcKeyword, SWP_NOZORDER);
		m_cmbEngine.SetWindowPos(NULL, rcEngine, SWP_NOZORDER);

		m_ptDragStart	 = pt;
		UpdateWindow();
	}
}



void CDonutSearchBar::UpdateLayout2(const CPoint& pt)
{
	ResizeBar(0, pt.x - m_ptDragStart.x);
	m_ptDragStart	 = pt;
	UpdateWindow();
}


//public: //+++ Ƃprivateɖ߂Ƃ肠eXg.
void CDonutSearchBar::_AddToSearchBoxUnique(const CString &strURL)
{
	// search the same string
	int nCount = m_cmbKeyword.GetCount();

	for (int n = 0; n < nCount; ++n) {
		CString 	str;
		MtlGetLBTextFixed(m_cmbKeyword, n, str);

		if (strURL == str) {
			m_cmbKeyword.DeleteString(n);
			break;
		}
	}

	m_cmbKeyword.InsertString(0, strURL);
	m_cmbKeyword.SetCurSel(0);
}


//private:
void CDonutSearchBar::_OnEnterKeyDown(int flag)
{
	CString  str;

	int nIndexCmb = m_cmbKeyword.GetCurSel();
	if (nIndexCmb == -1)
		str = MtlGetWindowText(m_cmbKeyword);
	else
		MtlGetLBTextFixed(m_cmbKeyword.m_hWnd, nIndexCmb, str);

	//	m_cmbKeyword.GetLBText(nIndexCmb, str);

	checkToolBarWords();	//+++

	if ( !str.IsEmpty() ) {
		SHORT sShift = ::GetKeyState(VK_SHIFT);
		SHORT sCtrl  = ::GetKeyState(VK_CONTROL);

		if (sShift >= 0 && sCtrl >= 0) {
		  #if 1 //+++ urlΉ̂
			_OnCommand_SearchWeb(str);
		  #else
			OnItemSelected(str);
			_AddToSearchBoxUnique(str);
		  #endif
		} else {
		  #if 1 //+++ J[\ʒu̒PꂾI悤ɂĂ݂.
			str = _GetSelectText_OnCursor( GetEditCtrl() );
		  #else
			str = _GetSelectText( GetEditCtrl() );
		  #endif

			if (sCtrl < 0)
				SendMessage(GetTopLevelParent(), WM_USER_FIND_KEYWORD, (WPARAM) str.GetBuffer(0), TRUE );
			else if (sShift < 0)
				SendMessage(GetTopLevelParent(), WM_USER_FIND_KEYWORD, (WPARAM) str.GetBuffer(0), FALSE);
		}
	} else {
		m_cmbEngine.ShowDropDown(FALSE); //minit
	}
}



LRESULT CDonutSearchBar::OnCtlColor(UINT /*uMsg*/, WPARAM wParam, LPARAM lParam, BOOL &bHandled)
{
	bHandled = FALSE;

	if (g_bNoReposition == true)
		return 0;

	CRect	rcDesktop;
	::GetWindowRect(::GetDesktopWindow(), &rcDesktop);

	CRect	rcWnd;
	::GetWindowRect( (HWND) lParam, &rcWnd );

	if (rcDesktop.right <= rcWnd.right) {
		int    nDiff = rcWnd.right - rcDesktop.right;
		rcWnd.left	-= nDiff;
		rcWnd.right -= nDiff;
		::SetWindowPos( (HWND) lParam, NULL, rcWnd.left, rcWnd.top, 0, 0, SWP_NOSIZE );
	}

	return 0;
}



void CDonutSearchBar::OnItemSelected(const CString& str)
{
	int 	nTarCate	 = m_cmbEngine.GetCurSel();
	if (nTarCate == -1)
		return;

	CString strSearchEng = MtlGetWindowText(m_cmbEngine);

	BOOL	bFirst		 = TRUE;
	int 	nLoopCtn	 = 0;
	OpenSearch(str, strSearchEng, nLoopCtn, bFirst);
}


//public:
CString CDonutSearchBar::GetSearchIniPath()
{
  #if 1 //+++ Lq̌yʉ.
	CIniFileI pr( g_szIniFileName, _T("Search") );
	CString 	strPath = pr.GetString(_T("Path"));
	pr.Close();
  #else
	CString 	strPath;
	CIniFileI pr;

	pr.Open( g_szIniFileName, _T("Search") );
	pr.QueryString(strPath, _T("Path"), MAX_PATH);
	pr.Close();
  #endif

	if ( strPath.IsEmpty() ) {
		strPath = _GetFilePath( _T("Search\\Search.ini") );

		if (::GetFileAttributes(strPath) == 0xFFFFFFFF)
			strPath = _GetFilePath( _T("Search.ini") ); 		//ȑO̎dlGo
	}

	return strPath;
}


//public:
#if 1		//+++ ".url"ɋLqgł̌ɑΉ邽߁AC.
void CDonutSearchBar::OpenSearch(CString strWord, CString strSearchEng, int &nLoopCnt, BOOL &bFirst)
{
	if (m_bUseShortcut)
		ShortcutSearch(strWord, strSearchEng);

	if ( strSearchEng.IsEmpty() ) {
		m_cmbEngine.GetLBText(0, strSearchEng);
		if (strSearchEng.IsEmpty())
			return;
	}

	CString 	strSearchPath = GetSearchIniPath();
	DWORD		dwStatus;
	{
		CIniFileI	pr( g_szIniFileName, _T("Search") );
		dwStatus		= pr.GetValue( _T("Status"), 0 );
		m_bActiveWindow = (dwStatus & STS_ACTIVEWINDOW) != 0;
		//x pr.Close(); //+++
	}

	CIniFileI		pr(strSearchPath, strSearchEng);
	if (pr.GetValue(_T("Group"), 0 ) != 0) {
		pr.Close();
		OpenSearchGroup(strWord, strSearchEng, nLoopCnt, bFirst);
	} else {
		CString 	strOpenURL;
		if (GetOpenURLstr(strOpenURL, strWord, pr, CString()) == false)
			return;
		pr.Close();
		DWORD		 dwOpenFlags = 0;
		if (bFirst) {
			dwOpenFlags |= D_OPENFILE_ACTIVATE;
			bFirst		 = FALSE;
		}

		if (m_bActiveWindow) {
			dwOpenFlags |= D_OPENFILE_NOCREATE;
		}

		//DonutOpenFile(m_hWnd, strOpenURL, dwOpenFlags);
		_EXPROP_ARGS	args;
		args.strUrl 	   = strOpenURL;
		args.dwOpenFlag    = dwOpenFlags;
		args.strIniFile    = strSearchPath;
		args.strSection    = strSearchEng;
		args.strSearchWord = RemoveShortcutWord( MtlGetWindowText( GetEditCtrl() ) );
		::SendMessage(GetTopLevelParent(), WM_OPEN_WITHEXPROP, (WPARAM) &args, 0);
	}
}



bool CDonutSearchBar::GetOpenURLstr(CString& strOpenURL, const CString& strWord0, CIniFileI& pr, const CString& frontURL0)
{
	//URL̓ǂݍ
	CString 	 strFrontURL	 = pr.GetString( _T("FrontURL") );
	if ( strFrontURL.IsEmpty() ) {
		if (frontURL0.IsEmpty())
			return false;
		strFrontURL = frontURL0;
	}
	CString 	 strBackURL 	 = pr.GetString( _T("BackURL") );

	//tL[[h̓ǂݍ
	CString 	 strFrontKeyWord = pr.GetString( _T("FrontKeyWord") );
	CString 	 strBackKeyWord  = pr.GetString( _T("BackKeyWord") );

	//̍쐬
	CString strWord = strFrontKeyWord + strWord0 + strBackKeyWord;

	if (m_bFiltering)
		FilterString(strWord);		//SpXy[X̒u

	DWORD		 dwEncode	 = pr.GetValue(_T("Encode"), 0);	//GR[h
	pr.Close();
	if (dwEncode != 0)
		EncodeString(strWord, dwEncode);

	strOpenURL.Format("%s%s%s", strFrontURL, strWord, strBackURL);
	return true;
}

#else

void CDonutSearchBar::OpenSearch(CString strWord, CString strSearchEng, int &nLoopCnt, BOOL &bFirst)
{
	if (m_bUseShortcut)
		ShortcutSearch(strWord, strSearchEng);

	if ( strSearchEng.IsEmpty() ) {
		CString 	strText;
		m_cmbEngine.GetLBText(0, strText);
		strSearchEng = strText;
	}

	CString 	strSearchPath = GetSearchIniPath();
	CIniFileI	pr;

	DWORD		dwStatus	  = 0;
	pr.Open( g_szIniFileName, _T("Search") );
	pr.QueryValue( dwStatus, _T("Status") );
	pr.Close();
	m_bActiveWindow = (dwStatus & STS_ACTIVEWINDOW) != 0;

	pr.Open(strSearchPath, strSearchEng);
	DWORD		dwGroup 	  = 0;
	pr.QueryValue( dwGroup, _T("Group") );
	//x BOOL	bGroup		  = (dwGroup != 0) ? TRUE : FALSE;

	if (dwGroup != 0/*bGroup == TRUE*/) {
		OpenSearchGroup(strWord, strSearchEng, nLoopCnt, bFirst);
	} else {
		//URL̓ǂݍ
		DWORD		 dwCount = MAX_PATH;
		TCHAR		 cBuff[MAX_PATH];
		memset(cBuff, 0, MAX_PATH);
		pr.QueryValue(cBuff, _T("FrontURL"), &dwCount);
		CString 	 strFrontURL(cBuff);

		if ( strFrontURL.IsEmpty() )
			return;

		memset(cBuff, 0, MAX_PATH);
		pr.QueryValue(cBuff, _T("BackURL"), &dwCount);
		CString 	 strBackURL(cBuff);

		//tL[[h̓ǂݍ
		memset(cBuff, 0, MAX_PATH);
		pr.QueryValue(cBuff, _T("FrontKeyWord"), &dwCount);
		CString 	 strFrontKeyWord(cBuff);

		memset(cBuff, 0, MAX_PATH);
		pr.QueryValue(cBuff, _T("BackKeyWord"), &dwCount);
		CString 	 strBackKeyWord(cBuff);

		//̍쐬
		strWord = strFrontKeyWord + strWord + strBackKeyWord;

		if (m_bFiltering)
			FilterString(strWord);		//SpXy[X̒u

		DWORD		 dwEncode	 = 0;	//GR[h
		pr.QueryValue( dwEncode, _T("Encode") );

		if (dwEncode != 0)
			EncodeString(strWord, dwEncode);

		CString 	 strOpenURL;
		strOpenURL.Format("%s%s%s", strFrontURL, strWord, strBackURL);

		DWORD		 dwOpenFlags = 0;

		if (bFirst == TRUE) {
			dwOpenFlags |= D_OPENFILE_ACTIVATE;
			bFirst		 = FALSE;
		}

		if (m_bActiveWindow) {
			dwOpenFlags |= D_OPENFILE_NOCREATE;
		}

		//DonutOpenFile(m_hWnd, strOpenURL, dwOpenFlags);
		_EXPROP_ARGS	args;
		args.strUrl 	   = strOpenURL;
		args.dwOpenFlag    = dwOpenFlags;
		args.strIniFile    = strSearchPath;
		args.strSection    = strSearchEng;
		args.strSearchWord = RemoveShortcutWord( MtlGetWindowText( GetEditCtrl() ) );
		::SendMessage(GetTopLevelParent(), WM_OPEN_WITHEXPROP, (WPARAM) &args, 0);
	}

	pr.Close();
}

#endif


//private:
void CDonutSearchBar::OpenSearchGroup(const CString& strWord, const CString& strSearchEng, int &nLoopCnt, BOOL &bFirst)
{
	nLoopCnt++;

	if (nLoopCnt > 10)
		return;

	CString 	strSearchPath = GetSearchIniPath();
	CIniFileI	pr(strSearchPath, strSearchEng);

	DWORD		dwListCnt	  = 0;
	pr.QueryValue( dwListCnt, _T("ListCount") );

	for (int ii = 1; ii <= (int) dwListCnt; ii++) {
		CString 	strKey;
		strKey.Format("%02d", ii);
	  #if 1 //+++ Lq̌yʉ.
		CString 	strSearchEng2 = pr.GetString( strKey );
	  #else
		TCHAR		cBuff[MAX_PATH];
		DWORD		dwCount = MAX_PATH;
		pr.QueryValue(cBuff, strKey, &dwCount);
		CString 	strSearchEng2(cBuff);
	  #endif
		if ( strSearchEng2.IsEmpty() )
			continue;

		OpenSearch(strWord, strSearchEng2, nLoopCnt, bFirst);
	}
}



void CDonutSearchBar::EncodeString(CString &str, int dwEncode)	//minit
{
	CURLEncoder enc;

	if (dwEncode == 0)
		return;
	else if (dwEncode == ENCODE_SHIFT_JIS)
		enc.URLEncode_SJIS(str);
	else if (dwEncode == ENCODE_EUC)
		enc.URLEncode_EUC(str);
	else if (dwEncode == ENCODE_UTF8)
		enc.URLEncode_UTF8(str);
	else
		return;

	//ATLASSERT(FALSE);
}



void CDonutSearchBar::ShortcutSearch(CString &strWord, CString &strSearchEng)
{
	CString 	strSearchPath = GetSearchIniPath();

	if ( strWord.Left(1) == _T("\\") ) {
		DWORD	dwListCount = 0;
		int 	nFind		= strWord.Find(" ");
		CString strShort	= strWord.Mid(1, nFind - 1);

		{
			CIniFileI	pr( strSearchPath, _T("Search-List") );
			pr.QueryValue( dwListCount, _T("ListCount") );
			//x pr.Close();
		}

		if ( strShort.IsEmpty() )
			return;

		strWord = strWord.Mid(nFind + 1);

		CString 	strBuf;
		CString 	strKey;
		int 		nListCount	= dwListCount;

		for (int i = 1; i <= nListCount; i++) {
		  #if 1 //+++	Lq̌yʉ.
			//GW擾
			strKey.Format("%02d", i);
			CIniFileI		pr( strSearchPath, _T("Search-List") );
			CString 		strEngine = pr.GetString( strKey );
			pr.Close();
		  #else
			DWORD	dwCount;

			//GW擾
			strKey.Format("%02d", i);
			pr.Open( strSearchPath, _T("Search-List") );
			dwCount = MAX_PATH;
			pr.QueryValue(strBuf.GetBuffer(MAX_PATH), strKey, &dwCount);
			strBuf.ReleaseBuffer();
			pr.Close();
			CString 	strEngine = strBuf;
		  #endif
			//V[gJbgR[h擾
			CString strShortcutWord = GetShortcutWord(strEngine);

			//r
			if (strShort == strShortcutWord) {
				strSearchEng = strEngine;
				return;
			}
		}
	}
}



CString CDonutSearchBar::GetShortcutWord(const CString& strSearchEng)
{
  #if 1 //+++ Lq̌yʉ.
	CIniFileI	pr(GetSearchIniPath(), strSearchEng);
	return		pr.GetString( _T("ShortCutCode") );
  #else
	//x 	DWORD dwCount = MAX_PATH;
	CIniFileI	pr;
	CString 		strBuf;
	pr.Open(GetSearchIniPath(), strSearchEng);
	pr.QueryString( strBuf,  _T("ShortCutCode") );
	pr.Close();
	return strBuf;
  #endif
}



void CDonutSearchBar::_InitialEngine(LPVOID lpV)
{
	CComboBox	cmb( (HWND) lpV );

	cmb.ResetContent(); 	//minit
	//::WINNLSEnableIME(cmb,FALSE);

	CString 	strSearchPath = GetSearchIniPath();

	CIniFileI	pr( strSearchPath, _T("Search-List") );
	DWORD		dwListCnt	  = 0;
	pr.QueryValue( dwListCnt, _T("ListCount") );

	CString 	strKey;
	DWORD		dwCount 	  = MAX_PATH;

	for (int ii = 1; ii <= (int) dwListCnt; ii++) {
		strKey.Format("%02d", ii);
	  #if 1 //+++ ƕobt@̎gp炷.
		CString 	strTitle = pr.GetString( strKey );
	  #else
		TCHAR	cBuff[MAX_PATH];
		pr.QueryValue(cBuff, strKey, &dwCount);
		CString strTitle(cBuff);
	  #endif
		if ( strTitle.IsEmpty() )
			continue;

		cmb.AddString(strTitle);
	}

	pr.Close();

	DWORD		dwStatus	  = 0, dwIndex = 0;
	{
		CIniFileI	pr( g_szIniFileName, _T("SEARCH") );
		pr.QueryValue( dwStatus, _T("Status") );
		pr.QueryValue( dwIndex , _T("SelIndex") );
		//x pr.Close();
	}

	int 		nSelIndex	  = 0;

	if (dwStatus & STS_LASTSEL)
		nSelIndex = dwIndex;

	cmb.SetCurSel(nSelIndex);
}



void CDonutSearchBar::_InitialKeyword(LPVOID lpV)
{
	CComboBox	cmb( (HWND) lpV );

	{
		DWORD		dwStatus	 = 0;
		CIniFileI	pr( g_szIniFileName, _T("SEARCH") );
		pr.QueryValue( dwStatus, _T("Status") );
		//x pr.Close();
		if (dwStatus & STS_NO_REPOSITION)
			g_bNoReposition = true;
		if ( (dwStatus & STS_HISTORY_SAVE) != STS_HISTORY_SAVE )
			return;
	}

	DWORD		dwHistoryCnt = 0;
	CIniFileI	pr( _GetFilePath( _T("WordHistory.ini") ), _T("SEARCH_HISTORY") );
	pr.QueryValue( dwHistoryCnt, _T("HistorySaveCnt") );

	for (int ii = 0; ii < (int) dwHistoryCnt; ii++) {
		CString 	strKey;
		strKey.Format("KEYWORD%d", ii);

	  #if 1 //+++ ƕobt@̎gp炷.
		CString 	strKeyWord = pr.GetString( strKey );
	  #else
		TCHAR	cBuff[MAX_PATH];
		DWORD	dwCount = MAX_PATH;
		pr.QueryValue(cBuff, strKey, &dwCount);
		CString strKeyWord(cBuff);
	  #endif
		if ( strKeyWord.IsEmpty() )
			continue;

		cmb.AddString(strKeyWord);
	}

	//x pr.Close(); 	//+++
}



// public:
BYTE CDonutSearchBar::PreTranslateMessage(MSG *pMsg)
{
	UINT msg  = pMsg->message;
	int  vKey =  (int) pMsg->wParam;

	if (msg == WM_SYSKEYDOWN || msg == WM_SYSKEYUP || msg == WM_KEYDOWN) {
		if ( !IsWindowVisible() || !IsChild(pMsg->hwnd) )									// ignore
			return _MTL_TRANSLATE_PASS;

		// left or right pressed, check shift and control key.
		if (	vKey == VK_UP || vKey == VK_DOWN || vKey == VK_LEFT || vKey == VK_RIGHT
			 || vKey == VK_HOME || vKey == VK_END
			 || vKey == (0x41 + 'C' - 'A')
			 || vKey == (0x41 + 'V' - 'A')
			 || vKey == (0x41 + 'X' - 'A')
			 || vKey == VK_INSERT)
		{
			if (::GetKeyState(VK_SHIFT) < 0 || ::GetKeyState(VK_CONTROL) < 0)
				return _MTL_TRANSLATE_WANT; 												// pass to edit control
		}

		// return key have to be passed
		if (vKey == VK_RETURN) {
			return _MTL_TRANSLATE_WANT;
		}

		// other key have to be passed
		if (VK_LBUTTON <= vKey && vKey <= VK_HELP) {
			BOOL bAlt = HIWORD(pMsg->lParam) & KF_ALTDOWN;

			if (!bAlt && ::GetKeyState(VK_SHIFT) >= 0 && ::GetKeyState(VK_CONTROL) >= 0)	// not pressed
				return _MTL_TRANSLATE_WANT; 												// pass to edit control
		}
	}
  #if 1 //*+++	Ώ:o[ɃJ[\ԂCTRL+RETURNŕœƂA
		//		ǂ̏CTRL+ENTERŃG[oĂ悤Ȃ̂ANƐl
		//		킩Ȃ̂ŁAŋɃL[HČ떂.
	else if (msg == WM_CHAR && (vKey == VK_RETURN || vKey == 0x0a) && ::GetKeyState(VK_CONTROL) < 0) {
		if ( !IsWindowVisible() || !IsChild(pMsg->hwnd) )									// ignore
			return _MTL_TRANSLATE_PASS;
		return _MTL_TRANSLATE_HANDLE;
	}
  #endif

	return _MTL_TRANSLATE_PASS;
}



CEdit CDonutSearchBar::GetEditCtrl()
{
	return CEdit( m_cmbKeyword.GetDlgItem(IDC_EDIT/*1001*/) );
}



void CDonutSearchBar::SetFocusToEngine()
{
	::SetFocus(m_cmbEngine.m_hWnd);
	m_cmbEngine.ShowDropDown(TRUE);
}



//private:
void CDonutSearchBar::SaveHistory()
{
	DWORD		dwStatus		= 0;
	DWORD		dwHistoryMaxCnt = 10;

	{
		CIniFileI pr( g_szIniFileName, _T("SEARCH") );
		pr.QueryValue( dwStatus, _T("Status") );
		pr.QueryValue( dwHistoryMaxCnt, _T("HistoryCnt") );
		//x pr.Close();
	}

	DWORD		dwItemCount 	= m_cmbKeyword.GetCount();

	if (dwItemCount > dwHistoryMaxCnt)
		dwItemCount = dwHistoryMaxCnt;

	CString 	strFileName 	= _GetFilePath( _T("WordHistory.ini") );
	CString 	strSection		= _T("SEARCH_HISTORY");
	//x MtlIniDeleteSection(strFileName, strSection);	//+++ o[֐ɒu.
	CIniFileO	 pr(strFileName, strSection);
	pr.DeleteSection();
	pr.SetValue( dwItemCount, _T("HistorySaveCnt") );

	if (dwStatus & STS_HISTORY_SAVE) {
		for (int ii = 0; ii < (int) dwItemCount; ii++) {
			CString 	strKeyWord;
			MtlGetLBTextFixed(m_cmbKeyword.m_hWnd, ii, strKeyWord);

			CString 	strKey;
			strKey.Format("KEYWORD%d", ii);
			pr.SetValue(strKeyWord, strKey);
		}
	}

	//x pr.Close(); 	//+++
}



//public:
DROPEFFECT CDonutSearchBar::OnDragEnter(IDataObject *pDataObject, DWORD dwKeyState, CPoint /*point*/)
{
	if (m_bDragFromItself)
		return DROPEFFECT_NONE;

	_DrawDragEffect(false);

	m_bDragAccept = _MtlIsHlinkDataObject(pDataObject);
	return _MtlStandardDropEffect(dwKeyState);
}



DROPEFFECT CDonutSearchBar::OnDragOver(IDataObject *pDataObject, DWORD dwKeyState, CPoint /*point*/, DROPEFFECT dropOkEffect)
{
	if (m_bDragFromItself || !m_bDragAccept)
		return DROPEFFECT_NONE;

	return _MtlStandardDropEffect(dwKeyState) | _MtlFollowDropEffect(dropOkEffect) | DROPEFFECT_COPY;
}



void CDonutSearchBar::OnDragLeave()
{
	if (m_bDragFromItself)
		return;

	_DrawDragEffect(true);
}



//private:
void CDonutSearchBar::_DrawDragEffect(bool bRemove)
{
	CClientDC dc(m_wndKeyword.m_hWnd);

	CRect	  rect;

	m_wndKeyword.GetClientRect(rect);

	if (bRemove)
		MtlDrawDragRectFixed(dc.m_hDC, &rect, CSize(0, 0), &rect, CSize(2, 2), NULL, NULL);
	else
		MtlDrawDragRectFixed(dc.m_hDC, &rect, CSize(2, 2), NULL, CSize(2, 2),	NULL, NULL);
}



//public:
DROPEFFECT CDonutSearchBar::OnDrop(IDataObject *pDataObject, DROPEFFECT dropEffect, DROPEFFECT dropEffectList, CPoint /*point*/)
{
	if (m_bDragFromItself)
		return DROPEFFECT_NONE;

	_DrawDragEffect(true);

	DWORD		dwStatus = 0;
	{
		CIniFileI pr( g_szIniFileName, _T("SEARCH") );
		pr.QueryValue( dwStatus, _T("Status") );
		//x pr.Close(); 	//+++
	}

	CString 	strText;

	if (   MtlGetHGlobalText( pDataObject, strText)
		|| MtlGetHGlobalText( pDataObject, strText, ::RegisterClipboardFormat(CFSTR_SHELLURL) ) )
	{
		CEdit edit = GetEditCtrl();
		edit.SendMessage(WM_CHAR, 'P'); //m_cmbKeyword.GetCurSel() == -1ɂ邽߂̋̍ minit
		edit.SetWindowText(strText);

		BOOL  bSts = dwStatus & STS_DROP_GO;

		if (::GetKeyState(VK_SHIFT) < 0)
			bSts = !bSts;

		if (bSts) {
		  #if 1 //+++ urlΉ̂
			_OnCommand_SearchWeb(strText);
		  #else
			OnItemSelected(strText);
			_AddToSearchBoxUnique(strText);
		  #endif
		}

		return DROPEFFECT_COPY;
	}

	return DROPEFFECT_NONE;
}



void CDonutSearchBar::SetFont(HFONT hFont, BOOL bRedraw /*= TRUE*/)
{
	int h = GetFontHeight( hFont ); 			//+++
	m_nItemFontH   = h > 20 ? h+1 : 20+1;		//+++	8͓KȍŒTCY...
	m_nDefDlgH = h > 20 ? h+2 : 20+2;			//+++
	CDialogImpl<CDonutSearchBar>::SetFont(hFont, bRedraw);
	m_cmbEngine.SetFont(hFont, bRedraw);
	m_cmbKeyword.SetFont(hFont, bRedraw);
	m_wndKeyword.SetFont(hFont, bRedraw);
	if (m_wndToolBar.m_hWnd)
		m_wndToolBar.SetFont(hFont, bRedraw);

	_InitCombo();								//+++
}



//private:
void CDonutSearchBar::_SetVerticalItemCount(CComboBox &cmb, int count)
{
#if 1	//+++
	CRect rc;
	cmb.AddString("DUMMY");
	int   itemheight = cmb.GetItemHeight(0);
	cmb.DeleteString(0);
	cmb.GetClientRect(&rc);
	int dh	  = (itemheight > m_nDefDlgH) ? itemheight : m_nDefDlgH;
	rc.bottom = rc.top + dh + (itemheight/3) +itemheight * count + 2;	//+++ ̊ɂȂ悤ɁAKɌvZ
	cmb.MoveWindow(&rc);
#else
	CRect rc;
	cmb.AddString("dummy");
	int   itemheight = cmb.GetItemHeight(0);
	cmb.DeleteString(0);
	cmb.GetClientRect(&rc);
	rc.bottom += itemheight * count + 2;
	cmb.MoveWindow(&rc);
#endif
}



void CDonutSearchBar::_InitCombo()						//minit
{
	DWORD		dwHeightCnt = DEFAULT_HEIGHTCOUNT;
	DWORD		dwStatus	= 0;

	{
		CIniFileI pr( g_szIniFileName, _T("SEARCH")    );
		pr.QueryValue( dwStatus 	 , _T("Status")    );
		pr.QueryValue( dwHeightCnt	 , _T("HeightCnt") );
		//x pr.Close();
	}

	m_cmbEngine.SetItemHeight(-1, m_nItemFontH);
	m_cmbKeyword.SetItemHeight(-1, m_nItemFontH);

	if (dwStatus & STS_HEIGHTCOUNT) {
		int HeightCount = (int) dwHeightCnt;

		if (HeightCount < 1 || MAXHEIGHTCOUNT < HeightCount)
			HeightCount = DEFAULT_HEIGHTCOUNT;

		_SetVerticalItemCount(m_cmbEngine  , HeightCount);
		_SetVerticalItemCount(m_cmbKeyword, HeightCount);
	}

	if (dwStatus & STS_TEXT_FILTER)
		m_bFiltering = TRUE;
}



//public:
void CDonutSearchBar::ShowToolBarIcon(BOOL flag)
{
	if (flag) {
		if (m_bLoadedToolBar) {
			if ( ::IsWindow(m_wndToolBar.m_hWnd) )
				m_wndToolBar.ShowWindow(SW_NORMAL);
		} else {
			InitToolBar(/*+++  IDB_SEARCHBUTTON, IDB_SEARCHBUTTON_HOT,*/ m_nBmpCX, m_nBmpCY, RGB(255, 0, 255) );
			m_wndToolBar.ShowWindow(SW_NORMAL);
			//m_bShowToolBar   = TRUE;
			//m_bLoadedToolBar = TRUE;
		}
	} else {
		if (m_bLoadedToolBar) {
			m_wndToolBar.ShowWindow(SW_HIDE);
		}
	}

	m_bShowToolBar = flag;

	//TCYύX
	CRect	rect;
	GetWindowRect(rect);
	CWindow( GetParent() ).ScreenToClient(rect);
	int 	width	= rect.right  - rect.left - 1;
	int 	height	= rect.bottom - rect.top;
	SetWindowPos(NULL, rect.left, rect.top, width,	 height, SWP_NOZORDER | SWP_NOREDRAW);
	SetWindowPos(NULL, rect.left, rect.top, width+1, height, SWP_NOZORDER);
}



//public:
void CDonutSearchBar::SearchWeb()
{
	CEdit	edit = GetEditCtrl();
	CString str  = MtlGetWindowText(edit);

	_OnCommand_SearchWeb(str);
}



void CDonutSearchBar::SearchHilight()
{
	CEdit	edit = GetEditCtrl();
	CString str  = MtlGetWindowText(edit);

	str = RemoveShortcutWord(str);
	_OnCommand_SearchHilight(str);
}



void CDonutSearchBar::SearchPage(BOOL bForward)
{
	_OnCommand_SearchPage(bForward);
}



BOOL CDonutSearchBar::GetToolIconState()
{
	return m_bShowToolBar;
}



#if 0	//+++ wb_.
void CDonutSearchBar::FilterString(CString &str)
{
	str.Replace( _T("@"), _T(" ") );
	/*int count = str.GetLength();
	   BOOL bFlag = FALSE;
	   int i = 0;
	   while(i < count){
		int c = str.GetAt(i);
		if((c&0xFF) == 0x81L) {
			if(i+1 < count){
				int c2 = str.GetAt(i+1);
				if((c2&0xFF) == 0x40L){
					str.SetAt(i,0x20L);
					str.Delete(i+1);
					count--;
				}
			}
		}
		i++;
	}*/
}
#endif



void CDonutSearchBar::ReloadSkin(int nCmbStyle)
{
	SetComboStyle(nCmbStyle);

	if ( !m_wndToolBar.IsWindow() )
		return;

	CImageList	imgs	= m_wndToolBar.GetImageList();
	CImageList	imgsHot = m_wndToolBar.GetHotImageList();
	CImageList	imgsDis = m_wndToolBar.GetDisabledImageList();	//+++

	_ReplaceImageList(GetSkinSeachBarPath(0), imgs	 , IDB_SEARCHBUTTON);
	_ReplaceImageList(GetSkinSeachBarPath(1), imgsHot, IDB_SEARCHBUTTON_HOT);

  #if 1 //+++ Disabled摜̑Ή.
	CString str = GetSkinSeachBarPath(2);
	int 	dis = 0;
	if (IsExistFile(str) == 0) {	//+++ 摜t@CȂ
		if (IsExistFile(GetSkinSeachBarPath(0))) {	//+++ ʏ킪
			str = GetSkinSeachBarPath(0);			//+++ ʏőp
		} else {									//+++ ʏȂ
			dis = IDB_SEARCHBUTTON_DIS; 			//+++ ftHgDisableg.
		}
	}
	_ReplaceImageList(str, imgsDis, dis);			//+++
  #endif

	InvalidateRect(NULL, TRUE);
	//m_wndToolBar.SetImageList(imgs);
	//m_wndToolBar.SetHotImageList(imgsHot);
	m_wndToolBar.InvalidateRect(NULL, TRUE);
}



void	CDonutSearchBar::SetComboStyle(int nCmbStyle)
{
	m_cmbEngine.SetDrawStyle (nCmbStyle);
	m_cmbKeyword.SetDrawStyle(nCmbStyle);
}

